
/////////////////////////////////////////////////////////
//                                                     //
//              Bold for Delphi                        //
//    Copyright (c) 2003 Borland                       //
//                                                     //
/////////////////////////////////////////////////////////

{ Global compiler directives }
{$include bold.inc}
unit BoldDatabaseAdapterET;

interface

uses
  EasyTable,
  BoldAbstractDataBaseAdapter,
  BoldDBInterfaces,
  BoldETInterfaces;

type
  { forward declarations }
  TBoldDatabaseAdapterET = class;

  { TBoldDatabaseAdapterET }
  TBoldDatabaseAdapterET = class(TBoldABStractDatabaseAdapter)
  private
    fBoldDatabase: TBoldETDatabase;
    procedure SetDataBase(const Value: TEasyDatabase);
    function GetDataBase: TEasyDatabase;
  protected
    procedure ReleaseBoldDatabase; override;
    function GetDataBaseInterface: IBoldDatabase; override;
  public
    destructor destroy; override;
  published
    property DataBase: TEasyDatabase read GetDataBase write SetDataBase;
    {$IFNDEF T2H}
    property DatabaseEngine;
    {$ENDIF}
  end;
{$R *.dcr}
implementation

uses
  SysUtils,
  BoldDefs,
  BoldRev;

{ TBoldDatabaseAdapterET }      

destructor TBoldDatabaseAdapterET.destroy;
begin
  Changed;
  FreePublisher;
  FreeAndNil(fBoldDatabase);
  inherited;                   
end;

function TBoldDatabaseAdapterET.GetDataBase: TEasyDatabase;
begin
  result := InternalDatabase as TEasyDatabase;
end;

function TBoldDatabaseAdapterET.GetDataBaseInterface: IBoldDatabase;
begin
  if not assigned(Database) then
    raise EBold.CreateFmt('%s.GetDatabaseInterface: The adapter is not connected to a database', [classname]); 
  if not assigned(fBoldDatabase) then
    fBoldDatabase := TBoldETDatabase.create(Database, SQLDataBaseConfig);
  result := fBoldDatabase;
end;

procedure TBoldDatabaseAdapterET.ReleaseBoldDatabase;
begin
  FreeAndNil(fBoldDatabase);
end;

procedure TBoldDatabaseAdapterET.SetDataBase(const Value: TEasyDatabase);
begin
  SqlDataBaseConfig.ColumnTypeForBlob := 'BLOB';
  SqlDataBaseConfig.ColumnTypeForCurrency := 'CURRENCY';
  SqlDataBaseConfig.ColumnTypeForDate := 'DATE';
  SqlDataBaseConfig.ColumnTypeForDateTime := 'TIMESTAMP';
  SqlDataBaseConfig.ColumnTypeForInteger := 'INTEGER';
  SqlDataBaseConfig.ColumnTypeForSmallInt := 'INTEGER';
  SqlDataBaseConfig.ColumnTypeForString := 'VARCHAR(%D)';
  SqlDataBaseConfig.ColumnTypeForFloat := 'FLOAT';
  SqlDataBaseConfig.ColumnTypeForTime := 'TIME';
  SqlDataBaseConfig.QuoteNonStringDefaultValues := True;
  InternalDatabase := value;
end;

initialization

end.